// For descriptions, please see files: mt19937ar.h and mt19937ar.cpp

#include <stdio.h> // sprintf()
#include "PRNG.h"

MT::MT(long s) {
    int from = IDLING;

    seeding = s;
    setMT(seeding, from);
}

MT::MT(long s, int from) {
    seeding = s;
    setMT(seeding, from);
}

void setMT(long seed, int from) { /* (long)time(NULL) */
    char *stop;
    char buffer[SMALL_BUFFER_SIZE];
    char os[SMALL_BUFFER_SIZE];
    int k;
    long full_seed;
    unsigned long init[KEY_LENGTH];

    if(seed < TEN_DIGITS) {
        full_seed = seed + TEN_DIGITS; /* 1000123456, for example. */
    } else {
        full_seed = seed;
    }

    os[0] = '\0';
    sprintf(os, "%ld", full_seed);
/*
0123456789
1339415048
    415   
     150  
      504 
       048
*/
    memset(buffer, 0, SMALL_BUFFER_SIZE);
    memcpy(buffer, &os[4], 3);
    init[0] = strtol(buffer, &stop, 16);
    memcpy(buffer, &os[5], 3);
    init[1] = strtol(buffer, &stop, 16);
    memcpy(buffer, &os[6], 3);
    init[2] = strtol(buffer, &stop, 16);
    memcpy(buffer, &os[7], 3);
    init[3] = strtol(buffer, &stop, 16);
    init_by_array(init, KEY_LENGTH);

    for(k = 0; k < from; ++k) {
        genrand_int32();
    }

}
