#ifndef RANNU_H
#define RANNU_H

#define VERSION 1.01
#define BITMAP_BUTTON_HEIGHT 81
#define BITMAP_BUTTON_WIDTH 72
#define BUFFER_SIZE 384
#define BUTTON_HEIGHT 30
#define BUTTON_WIDTH 68
#define CORNER_X 1 
#define CORNER_Y 22 
#define ERROR_TEXT "error.txt"
#define FIELD_HEIGHT 27
#define FIRST_PART_OF_FILE 128
#define HELP_FILE_NAME "rannu.pdf"
#define IDH_DIAGONAL 109
#define IDH_KILOBYTES 108
#define IDH_MANAGE 107
#define IDH_SETTING 105
#define IDH_TEXT_CSV 104
#define IDH_VARIANCE 106
#define IDH_VERSION 110
#define LARGE_NUMBER 2147483647
#define LARGE_PANE_X 1022
#define LARGE_PANE_Y 716
#define MAIN_BUFFER_SIZE 4224
#define MAIN_HEIGHT 316
#define MAIN_WIDTH 513
#define MAIN_X 252
#define MAIN_Y 214
#define MANAGE_BUTTON_LEFT 350
#define MANAGE_CAPTION_BUTTON_HEIGHT 26
#define MANAGE_CAPTION_BUTTON_WIDTH 50
#define MANAGE_CLOSE_BUTTON_TOP 208
#define MANAGE_DIRECTORY_HEIGHT 28
#define MANAGE_DIRECTORY_LABEL_HEIGHT 18
#define MANAGE_DIRECTORY_LABEL_LEFT 410
#define MANAGE_DIRECTORY_LABEL_TOP 67
#define MANAGE_DIRECTORY_LABEL_WIDTH 60
#define MANAGE_DIRECTORY_LEFT 7
#define MANAGE_DIRECTORY_TOP 64
#define MANAGE_DIRECTORY_WIDTH 395
#define MANAGE_FROM_HEIGHT 26
#define MANAGE_FROM_LABEL_HEIGHT 18
#define MANAGE_FROM_LABEL_LEFT 9
#define MANAGE_FROM_LABEL_TOP 18
#define MANAGE_FROM_LABEL_WIDTH 31
#define MANAGE_FROM_LEFT 50
#define MANAGE_FROM_TOP 15
#define MANAGE_FROM_WIDTH 40
#define MANAGE_HEIGHT 300
#define MANAGE_HELP_BUTTON_TOP 251
#define MANAGE_IDLING_HEIGHT 26
#define MANAGE_IDLING_LABEL_HEIGHT 18
#define MANAGE_IDLING_LABEL_LEFT 16
#define MANAGE_IDLING_LABEL_TOP 64
#define MANAGE_IDLING_LABEL_WIDTH 33
#define MANAGE_IDLING_LEFT 58
#define MANAGE_IDLING_TOP 61
#define MANAGE_IDLING_WIDTH 96
#define MANAGE_KB_HEIGHT 25
#define MANAGE_KB_LABEL_HEIGHT 18
#define MANAGE_KB_LABEL_LEFT 446
#define MANAGE_KB_LABEL_TOP 104
#define MANAGE_KB_LABEL_WIDTH 18
#define MANAGE_KB_LEFT 352
#define MANAGE_KB_TOP 101
#define MANAGE_KB_WIDTH 89
#define MANAGE_KILOBYTES_BUTTON_WIDTH 23
#define MANAGE_LINES_BUTTON_WIDTH 36
#define MANAGE_LINES_HEIGHT 25
#define MANAGE_LINES_LABEL_HEIGHT 18
#define MANAGE_LINES_LABEL_LEFT 113
#define MANAGE_LINES_LABEL_TOP 158
#define MANAGE_LINES_LABEL_WIDTH 30
#define MANAGE_LINES_LEFT 7
#define MANAGE_LINES_TOP 155
#define MANAGE_LINES_WIDTH 97
#define MANAGE_LIST_BUFFER_SIZE 32
#define MANAGE_LIST_SIZE 8
#define MANAGE_PRNG_HEIGHT 132
#define MANAGE_PRNG_LEFT 162
#define MANAGE_PRNG_TOP 156
#define MANAGE_PRNG_WIDTH 170
#define MANAGE_RANNU_TEXT_BUTTON_WIDTH 61
#define MANAGE_SAVE_BUTTON_TOP 165
#define MANAGE_SEED_HEIGHT 26
#define MANAGE_SEED_LABEL_HEIGHT 18
#define MANAGE_SEED_LABEL_LEFT 16
#define MANAGE_SEED_LABEL_TOP 99
#define MANAGE_SEED_LABEL_WIDTH 33
#define MANAGE_SEED_LEFT 58
#define MANAGE_SEED_TOP 96
#define MANAGE_SEED_WIDTH 96
#define MANAGE_TEXT "manage.txt"
#define MANAGE_TEXT "manage.txt"
#define MANAGE_TEXT_LINE_COUNT 9
#define MANAGE_TO_HEIGHT 26
#define MANAGE_TO_LABEL_HEIGHT 18
#define MANAGE_TO_LABEL_LEFT 100
#define MANAGE_TO_LABEL_TOP 18
#define MANAGE_TO_LABEL_WIDTH 14
#define MANAGE_TO_LEFT 123
#define MANAGE_TO_TOP 15
#define MANAGE_TO_WIDTH 40
#define MANAGE_WHERE_BUTTON_LEFT 7
#define MANAGE_WHERE_BUTTON_TOP 30
#define MANAGE_WIDTH 485
#define MENU_BAR_HEIGHT 19
#define NONSAMPLING_PERIOD 1.0
#define NOT_FOUND -1
#define REMOVE_ERROR_TEXT "remove_e.txt"
#define SMALL_PANE_HEIGHT 172
#define SMALL_PANE_WIDTH 276
#define SMALL_PANE_X 374
#define SMALL_PANE_Y 281
#define STATUS_BAR_HEIGHT 30
#define VERSION_CLOSE_LEFT 196
#define VERSION_COPYRIGHT_LEFT 57
#define VERSION_COPYRIGHT_TOP 138
#define VERSION_COPYRIGHT_WIDTH 150
#define VERSION_HEIGHT 259
#define VERSION_HELP_LEFT 11
#define VERSION_HELP_TOP 191
#define VERSION_RANNU_FLTK_LEFT 98
#define VERSION_RANNU_FLTK_TOP 93
#define VERSION_RANNU_FLTK_WIDTH 90
#define VERSION_TEXT "version.txt"
#define VERSION_WIDTH 269
#define VERSION_WINDOWS_LEFT 90
#define VERY_SMALL_BUFFER_SIZE 16
#include "Count99.h"
#include "NAMES.h"
#include "Numbered.h"
#include "OS-specific.h"
#include "rannuText.h"

typedef struct MANAGE_MEMO MANAGE_MEMO;
struct MANAGE_MEMO {
    bool csv, grouping, pleaseCheck, produce_rannu_text, showWhere;
    std::string FULL_PATH_NAME, pathName, statusBarText;
    int from, interval_0, interval_1, lineCount, rannu_h, rannu_w, rannu_x, rannu_y, prng, whichCorner;
    long kilo, seed;
};

bool rannuCsvTouched();
long modified_file(const char *file);
NAMES driveDirectoryBase(std::string & s);
std::string inheritTerms();
std::string standardTerms();
void bingo5_cb(Fl_Widget *, void *);
void center_cb(Fl_Widget *, void *);
void close_manage_cb(Fl_Widget *, void *);
void close_version_cb(Fl_Widget *, void *);
void copy_cb(Fl_Widget *, void *);
void corner_cb(Fl_Widget *, void *);
void count_cb(Fl_Widget *, void *);
void csv_cb(Fl_Widget *, void *);
void diagonal_cb(Fl_Widget *, void *);
void figures(char *buffer, int value);
void figures(char *buffer, long value);
void focus_cb(Fl_Widget *, void *);
void grouping_cb(Fl_Widget *, void *);
void guide(bool comments);
void help_cb(Fl_Widget *, void *);
void KB_cb(Fl_Widget *, void *);
void large_cb(Fl_Widget *, void *);
void line_count_cb(Fl_Widget *, void *);
void loto6_cb(Fl_Widget *, void *);
void loto7_cb(Fl_Widget *, void *);
void manage_cb(Fl_Widget *, void *);
void mean_cb(Fl_Widget *, void *);
void miniloto_cb(Fl_Widget *, void *);
void MT_cb(Fl_Widget *, void *);
void quit_cb(Fl_Widget *, void *);
void rannu_csv_cb(Fl_Widget *, void *);
void rannu_text_cb(Fl_Widget *, void *);
void redraw_cb(Fl_Widget *, void *);
void replaceSlashWithYen(char *buffer);
void right_cb(Fl_Widget *, void *);
void save_cb(Fl_Widget *, void *);
void small_cb(Fl_Widget *, void *);
void standard_cb(Fl_Widget *, void *);
void text_cb(Fl_Widget *, void *);
void timer_cb(void *);
void trimming(const char *t, char *b);
void under_cb(Fl_Widget *, void *);
void version_cb(Fl_Widget *, void *);
void where_cb(Fl_Widget *, void *);
void xorshift_cb(Fl_Widget *, void *);

#endif // RANNU_H
